<?php
/**
 * Plugin Helper File
 *
 * @package         AdminBar Docker
 * @version         2.3.1
 *
 * @author          Peter van Westen <peter@nonumber.nl>
 * @link            http://www.nonumber.nl
 * @copyright       Copyright © 2012 NoNumber All Rights Reserved
 * @license         http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

defined('_JEXEC') or die;

/**
 * Plugin that docks the admin toolbars
 */
class plgSystemAdminBarDockerHelper
{
	function __construct(&$params)
	{
		$this->params = $params;
	}

	/*
	 * Place scripts and styles and load language
	 */
	function onAfterDispatch()
	{
		JHtml::_('behavior.mootools');

		require_once JPATH_PLUGINS . '/system/nnframework/helpers/versions.php';
		$version = NoNumberVersions::getXMLVersion('adminbardocker', 'system', null, 1);

		$this->template = JFactory::getApplication()->getTemplate();
		if (!file_exists(JPATH_PLUGINS . '/system/adminbardocker/templates/' . $this->template . '/script.js')) {
			// if template folder does not exist, fall back on default template bluestork
			$this->template = 'bluestork';
		}

		$ignorecookie = 0;
		if ($this->params->showonpopups != 1) {
			$tmpl = JFactory::getApplication()->input->get('tmpl', 'index');
			if (!in_array($tmpl, array('index', 'cpanel')) || JFactory::getApplication()->input->getInt('nn_qp')) {
				if ($this->params->showonpopups == 2) {
					$this->params->dock_state = 'docked';
					$ignorecookie = 1;
				} else {
					return;
				}
			}
		}

		JFactory::getDocument()->addScript(JURI::root(true) . '/media/adminbardocker/templates/' . $this->template . '/script.js' . $version);
		JFactory::getDocument()->addScript(JURI::root(true) . '/media/adminbardocker/js/script.js' . $version);
		JFactory::getDocument()->addStyleSheet(JURI::root(true) . '/media/adminbardocker/css/style.css' . $version);
		JFactory::getDocument()->addStyleSheet(JURI::root(true) . '/media/adminbardocker/templates/' . $this->template . '/style.css' . $version);


		$set_cookies = array();
		if ($this->params->dock_state == 'undocked') {
			$set_cookies[] = 'ABD_setCookie( \'abd_dock_state\', \'undocked\' );';
		}

		$settings_url = '';
		if (JFactory::getUser()->authorise('core.admin')) {
			$settings_url = JURI::base() . 'index.php?option=com_plugins&filter_search=adminbar%20docker';
		}
		$script = "
			var abd_top = [];
			var abd_toggle_top = [];
			var abd_toggle_bottom = [];
			var abd_bottom = [];
			var abd_settings_url = '" . $settings_url . "';
			window.addEvent( 'domready', function() {
				" . implode("\n\t\t\t\t", $set_cookies) . "
				new AdminBarDocker(
					'" . $this->template . "',
				 	[
				 		'" . addslashes(JText::_('ABD_SETTINGS')) . "',
						'" . addslashes(JText::_('ABD_UNDOCK')) . "',
						'" . addslashes(JText::_('ABD_DOCK')) . "',
						'" . addslashes(JText::_('ABD_RELOAD')) . "',
						'" . addslashes(JText::_('ABD_TO_TOP')) . "',
						'" . addslashes(JText::_('ABD_TO_BOTTOM')) . "',
					],
					" . $this->params->hidetopbar . ",
					" . $ignorecookie . "
				);
			});
		";
		JFactory::getDocument()->addScriptDeclaration(preg_replace("#\s+#s", ' ', $script));
	}
}
