<?php
/**
 * Library for dump variables and profiling PHP code
 * The idea and the look was taken from http://krumo.sourceforge.net/
 * PHP version 5.3 or higher
 * @package     JBDump
 * @author      admin@joomla-book.ru
 * @link        http://joomla-book.ru/
 * @copyright   Copyright (c) 2009-2011 Joomla-book.ru
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.event.helper');

if (!class_exists('jbdump')) {
    require_once(dirname(__FILE__) . DS . 'class.jbdump.php');
}

class plgSystemJBDump extends JPlugin
{

    /**
     * Plugin init
     */
    function plgSystemJBDump($subject, $params)
    {
        parent::__construct($subject, $params);
    }


    /**
     * JBDump init
     */
    function onAfterInitialise()
    {

        $logPath = $this->params->get('log_path', JPATH_ROOT . DS . 'logs');
        if (empty($logPath)) {
            $logPath = JPATH_ROOT . DS . 'logs';
        }

        // init and configuration JBDump library
        $params = array(
            'root' => JPATH_SITE,
            'log'  => array(
                'path' => $logPath,
            )
        );
        
        // init jbdump
        JBDump::i($params);
        
        if ((int)$this->params->get('enabled', 1)) {
            JBDump::on();
        } else {
            JBDump::off();
        }
        
    }

}

// usability methods
if (!function_exists('d')) {
    function d($var = 'JBDump::variable no set', $isDie = true, $name = '...')
    {
        $_this = JBDump::i();

        if ($var !== 'JBDump::variable no set') {
            if ($_this->isDebug()) {

                $params = array('trace' => debug_backtrace());
                $_this->dump($var, $name, $params);

                if ($isDie) {
                    die('JBDump_die');
                }
            }
        }

        return $_this;
    }

}

if (!function_exists('l')) {
    function l($entry, $mark = '...')
    {
        $params = array('trace' => debug_backtrace());
        return JBDump::log($entry, $mark, $params);
    }
}

if (!function_exists('m')) {
    function m($text)
    {
        return JBDump::mark($text);
    }
}
